diff --git a/bots/naughty/ubuntu-1604/9487-nsupdate-assert-2 b/bots/naughty/ubuntu-1604/9487-nsupdate-assert-2
new file mode 100644
index 000000000000..aff060c5f926
--- /dev/null
+++ b/bots/naughty/ubuntu-1604/9487-nsupdate-assert-2
@@ -0,0 +1,5 @@
+Traceback (most recent call last):
+  File "test/verify/check-realms", line *, in testIpa
+    b.wait_in_text('#dashboard_setup_server_dialog', "Fingerprint")
+*
+warning: Cockpit could not contact the given host.
diff --git a/src/ssh/Makefile-ssh.am b/src/ssh/Makefile-ssh.am
index 41ba78390b73..8743f071490d 100644
--- a/src/ssh/Makefile-ssh.am
+++ b/src/ssh/Makefile-ssh.am
@@ -78,12 +78,14 @@ EXTRA_DIST += \
 	src/ssh/test_rsa.pub \
 	src/ssh/mock_known_hosts \
 	src/ssh/mock-pid-cat \
+	src/ssh/mock-bin/sss_ssh_knownhostsproxy \
 	src/ssh/mock-config \
 	src/ssh/invalid_known_hosts \
 	$(NULL)
 
 noinst_SCRIPTS += \
 	src/ssh/mock-pid-cat \
+	src/ssh/mock-bin/sss_ssh_knownhostsproxy \
 	$(NULL)
 
 noinst_PROGRAMS += $(SSH_CHECKS)
diff --git a/src/ssh/cockpitsshrelay.c b/src/ssh/cockpitsshrelay.c
index 41286c3ebeae..e80048d8ea93 100644
--- a/src/ssh/cockpitsshrelay.c
+++ b/src/ssh/cockpitsshrelay.c
@@ -531,6 +531,66 @@ static void cleanup_knownhosts_file (void)
     }
 }
 
+static gboolean
+write_tmp_knownhosts_file (CockpitSshData *data,
+                           const gchar *content,
+                           const gchar **problem)
+{
+  FILE *fp = NULL;
+
+  tmp_knownhost_file = create_knownhosts_temp ();
+  if (!tmp_knownhost_file)
+    {
+      *problem = "internal-error";
+      return FALSE;
+    }
+  atexit (cleanup_knownhosts_file);
+
+  fp = fopen (tmp_knownhost_file, "a");
+  if (fp == NULL)
+    {
+      g_warning ("%s: couldn't open temporary known host file for data: %s",
+                 data->logname, tmp_knownhost_file);
+      *problem = "internal-error";
+      return FALSE;
+    }
+
+  if (fputs (content, fp) < 0)
+    {
+      g_warning ("%s: couldn't write data to temporary known host file: %s",
+                 data->logname, g_strerror (errno));
+      fclose (fp);
+      *problem = "internal-error";
+      return FALSE;
+    }
+
+  fclose (fp);
+  return TRUE;
+}
+
+/**
+ * prepend_host_port:
+ *
+ * Transform lines of keys to an ssh known_hosts format with lines of
+ * "[host]:port key".
+ */
+static gchar *
+prepend_host_port (const gchar *host,
+                   guint port,
+                   const gchar *keys)
+{
+  gchar **lines = g_strsplit (keys, "\n", 0);
+  gchar **line;
+  GString *result = g_string_new (NULL);
+
+  for (line = lines; *line; ++line)
+    g_string_append_printf (result, "[%s]:%d %s\n", host, port, *line);
+
+  g_strfreev (lines);
+  return g_string_free (result, FALSE);
+
+}
+
 /**
  * set_knownhosts_file:
  *
@@ -546,7 +606,9 @@ set_knownhosts_file (CockpitSshData *data,
 {
   gboolean host_known;
   const gchar *knownhosts_data;
-  const gchar *problem;
+  const gchar *problem = NULL;
+  gchar *sout = NULL;
+  gchar *serr = NULL;
 
   gchar *authorize_knownhosts_data = NULL;
 
@@ -563,35 +625,10 @@ set_knownhosts_file (CockpitSshData *data,
   /* $COCKPIT_SSH_KNOWN_HOSTS_DATA has highest priority */
   if (knownhosts_data)
     {
-      FILE *fp = NULL;
-      tmp_knownhost_file = create_knownhosts_temp ();
-      if (!tmp_knownhost_file)
-        {
-          problem = "internal-error";
-          goto out;
-        }
-      atexit (cleanup_knownhosts_file);
-
-      fp = fopen (tmp_knownhost_file, "a");
-      if (fp == NULL)
-        {
-          g_warning ("%s: couldn't open temporary known host file for data: %s",
-                     data->logname, tmp_knownhost_file);
-          problem = "internal-error";
-          goto out;
-        }
-
-      if (fputs (knownhosts_data, fp) < 0)
-        {
-          g_warning ("%s: couldn't write to data to temporary known host file: %s",
-                     data->logname, g_strerror (errno));
-          fclose (fp);
-          problem = "internal-error";
-          goto out;
-        }
-
-      fclose (fp);
-      data->ssh_options->knownhosts_file = tmp_knownhost_file;
+      if (write_tmp_knownhosts_file (data, knownhosts_data, &problem))
+        data->ssh_options->knownhosts_file = tmp_knownhost_file;
+      else
+        goto out;
     }
 
   /* now check the default global ssh file */
@@ -622,6 +659,52 @@ set_knownhosts_file (CockpitSshData *data,
         }
     }
 
+  /* last (most expensive) fallback is to ask sssd's ssh known_hosts proxy */
+  if (!host_known && tmp_knownhost_file == NULL)
+    {
+      char port_str[10];
+      const gchar *argv [] = {
+          "sss_ssh_knownhostsproxy",
+          "--pubkey",
+          "--port", port_str,
+          host,
+          NULL
+      };
+      GError *error = NULL;
+      gint exit;
+
+      g_debug ("%s: host not known in any local file, asking sssd", data->logname);
+
+      snprintf (port_str, sizeof (port_str), "%u", port);
+
+      if (g_spawn_sync (NULL, (gchar **) argv, NULL, G_SPAWN_SEARCH_PATH, NULL,
+                        NULL, &sout, &serr, &exit, &error))
+        {
+          sout = g_strstrip (sout);
+          if (exit == 0 && strlen (sout) > 0)
+            {
+              gchar *known_hosts = prepend_host_port (host, port, sout);
+              gboolean res = write_tmp_knownhosts_file (data, known_hosts, &problem);
+              g_free (known_hosts);
+              if (!res)
+                goto out;
+
+              /* this should always be known now, but let's make double-sure */
+              host_known = cockpit_is_host_known (tmp_knownhost_file, host, port);
+              if (host_known)
+                data->ssh_options->knownhosts_file = tmp_knownhost_file;
+              else
+                g_warning ("sss_ssh_knownhostsproxy reported key for %s:%u which is not known to cockpit_is_host_known()", host, port);
+            } else {
+              /* the --pubkey option is not yet known by many older distributions; don't show the error in the log */
+              g_debug ("sss_ssh_knownhostsproxy failed: exit code %i, output '%s', error '%s'", exit, sout, serr);
+            }
+        } else {
+          g_debug ("Failed to run sss_ssh_knownhostsproxy: %s", error->message);
+          g_clear_error (&error);
+        }
+    }
+
   g_debug ("%s: using known hosts file %s", data->logname, data->ssh_options->knownhosts_file);
   if (!data->ssh_options->allow_unknown_hosts && !host_known)
     {
@@ -634,6 +717,8 @@ set_knownhosts_file (CockpitSshData *data,
   problem = NULL;
 out:
   g_free (authorize_knownhosts_data);
+  g_free (sout);
+  g_free (serr);
   return problem;
 }
 
diff --git a/src/ssh/mock-bin/sss_ssh_knownhostsproxy b/src/ssh/mock-bin/sss_ssh_knownhostsproxy
new file mode 100755
index 000000000000..57007c9b9168
--- /dev/null
+++ b/src/ssh/mock-bin/sss_ssh_knownhostsproxy
@@ -0,0 +1,18 @@
+#!/bin/sh
+set -eu
+
+if [ "$1" != "--pubkey" ]; then
+    echo "This mock only supports the --pubkey operation" >&2
+    exit 1
+fi
+
+# recognize --port, but ignore it
+if [ "$2" = "--port" ]; then
+    shift 2
+fi
+
+# if the host does not match, don't print anything
+# sss_ssh_knownhostsproxy still succeeds in this case
+if [ "$2" = "$COCKPIT_MOCK_SSS_KNOWN_HOSTS_HOST" ]; then
+    echo "$COCKPIT_MOCK_SSS_KNOWN_HOSTS_KEY"
+fi
diff --git a/src/ssh/test-sshbridge.c b/src/ssh/test-sshbridge.c
index e86f63938736..724c9383e1f1 100644
--- a/src/ssh/test-sshbridge.c
+++ b/src/ssh/test-sshbridge.c
@@ -49,7 +49,6 @@ typedef struct {
   /* setup_mock_sshd */
   GPid mock_sshd;
   guint16 ssh_port;
-
 } TestCase;
 
 typedef struct {
@@ -59,6 +58,8 @@ typedef struct {
     const char *username;
     const char *knownhosts_data;
     const char *knownhosts_file;
+    const char *knownhosts_sssd;
+    const char *knownhosts_sssd_host;
     const char *config;
     const char *problem;
     gboolean allow_unknown;
@@ -232,6 +233,7 @@ setup (TestCase *tc,
   gchar **env = NULL;
   gchar *host = NULL;
   gchar *knownhosts_data = NULL;
+  gchar *path = NULL;
 
   alarm (TIMEOUT);
 
@@ -265,11 +267,28 @@ setup (TestCase *tc,
                               knownhosts_data, TRUE);
     }
 
+  if (fixture && fixture->knownhosts_sssd)
+    {
+      g_assert (fixture->knownhosts_sssd_host != NULL);
+      env = g_environ_setenv (env, "COCKPIT_MOCK_SSS_KNOWN_HOSTS_HOST",
+                              fixture->knownhosts_sssd_host, TRUE);
+      env = g_environ_setenv (env, "COCKPIT_MOCK_SSS_KNOWN_HOSTS_KEY",
+                              fixture->knownhosts_sssd, TRUE);
+
+      path = g_strjoin (":",
+                        SRCDIR "/src/ssh/mock-bin",
+                        g_environ_getenv (env, "PATH") ?: "",
+                        NULL);
+
+      env = g_environ_setenv (env, "PATH", path, TRUE);
+    }
+
   tc->transport = start_bridge (env, (gchar **) argv);
   g_signal_connect (tc->transport, "closed", G_CALLBACK (on_closed_set_flag), &tc->closed);
   g_strfreev (env);
   g_free (host);
   g_free (knownhosts_data);
+  g_free (path);
 }
 
 static void
@@ -561,10 +580,11 @@ test_echo_large (TestCase *tc,
 }
 
 
-static const gchar MOCK_RSA_KEY[] = "ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQCYzo07OA0H6f7orVun9nIVjGYrkf8AuPDScqWGzlKpAqSipoQ9oY/mwONwIOu4uhKh7FTQCq5p+NaOJ6+Q4z++xBzSOLFseKX+zyLxgNG28jnF06WSmrMsSfvPdNuZKt9rZcQFKn9fRNa8oixa+RsqEEVEvTYhGtRf7w2wsV49xIoIza/bln1ABX1YLaCByZow+dK3ZlHn/UU0r4ewpAIZhve4vCvAsMe5+6KJH8ft/OKXXQY06h6jCythLV4h18gY/sYosOa+/4XgpmBiE7fDeFRKVjP3mvkxMpxce+ckOFae2+aJu51h513S9kxY2PmKaV/JU9HBYO+yO4j+j24v";
+#define MOCK_RSA_KEY "ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQCYzo07OA0H6f7orVun9nIVjGYrkf8AuPDScqWGzlKpAqSipoQ9oY/mwONwIOu4uhKh7FTQCq5p+NaOJ6+Q4z++xBzSOLFseKX+zyLxgNG28jnF06WSmrMsSfvPdNuZKt9rZcQFKn9fRNa8oixa+RsqEEVEvTYhGtRf7w2wsV49xIoIza/bln1ABX1YLaCByZow+dK3ZlHn/UU0r4ewpAIZhve4vCvAsMe5+6KJH8ft/OKXXQY06h6jCythLV4h18gY/sYosOa+/4XgpmBiE7fDeFRKVjP3mvkxMpxce+ckOFae2+aJu51h513S9kxY2PmKaV/JU9HBYO+yO4j+j24v"
 
 static const gchar MOCK_RSA_FP[] = "0e:6a:c8:b1:07:72:e2:04:95:9f:0e:b3:56:af:48:e2";
 
+#define MOCK_DSA_PUB_KEY "ssh-dss AAAAB3NzaC1kc3MAAACBAIK3RTEWBw+rAPcYUM2Qq4kEw59gXpUQ/WvkdeY7QDO64MHaaorySj8xsraNudmQFh4xb/i5Q1EMnNchOFxtilfU5bUJgdTvetyZEWFL+2HxqBs8GaWRyB1vtSFAw3GO8VUEnjF844N3dNyLoc0NX8IvzwNIaQho6KTsueQlG1X9AAAAFQCXUl4a5UvElL4thi/8QlxR5PtEewAAAIBqNpl5MTBxKQu5jT0+WASa7pAqwT53ofv7ZTDIEokYRb57/nwzDgkcs1fsBRrI6eczJ/VlXWwKbsgkx2Nh3ZiWYwC+HY5uqRpDaj3HERC6LMn4dzdcl29fYeziEibCbRjJX5lZF2vIaA1Ewv8yT0UlunyHZRiyw4WlEglkf/NITAAAAIBxLsdBBXn+8qEYwWK9KT+arRqNXC/lrl0Fp5YyxGNGCv82JcnuOShGGTzhYf8AtTCY1u5oixiW9kea6KXGAKgTjfJShr7n47SZVfOPOrBT3VLhRdGGO3GblDUppzfL8wsEdoqXjzrJuxSdrGnkFu8S9QjkPn9dCtScvWEcluHqMw=="
 
 static void
 do_auth_conversation (CockpitTransport *transport,
@@ -692,6 +712,34 @@ static const TestFixture fixture_knownhost_data = {
   .ssh_command = BUILDDIR "/mock-echo"
 };
 
+static const TestFixture fixture_knownhost_sssd_known = {
+  .knownhosts_sssd = MOCK_RSA_KEY,
+  .knownhosts_sssd_host = "127.0.0.1",
+  .knownhosts_file = "/dev/null",
+  .ssh_command = BUILDDIR "/mock-echo"
+};
+
+static const TestFixture fixture_knownhost_sssd_known_multi_key = {
+  .knownhosts_sssd = MOCK_DSA_PUB_KEY "\n" MOCK_RSA_KEY,
+  .knownhosts_sssd_host = "127.0.0.1",
+  .knownhosts_file = "/dev/null",
+  .ssh_command = BUILDDIR "/mock-echo"
+};
+
+static const TestFixture fixture_knownhost_sssd_unknown = {
+  .knownhosts_sssd = MOCK_RSA_KEY,
+  .knownhosts_sssd_host = "somehost",
+  .knownhosts_file = "/dev/null",
+  .problem = "unknown-host"
+};
+
+static const TestFixture fixture_knownhost_sssd_badkey = {
+  .knownhosts_sssd = "ssh-rsa Ym9ndXMK",
+  .knownhosts_sssd_host = "127.0.0.1",
+  .knownhosts_file = "/dev/null",
+  .problem = "invalid-hostkey"
+};
+
 static void
 test_knownhost_data (TestCase *tc,
                      gconstpointer data)
@@ -1372,6 +1420,15 @@ main (int argc,
               setup, test_invalid_knownhost, teardown);
   g_test_add ("/ssh-bridge/knownhost-authorize-bad", TestCase, &fixture_authorize_host_key,
               setup, test_knownhost_data_prompt_bad, teardown);
+  g_test_add ("/ssh-bridge/knownhost-sssd-known", TestCase, &fixture_knownhost_sssd_known,
+              setup, test_echo_and_close, teardown);
+  g_test_add ("/ssh-bridge/knownhost-sssd-known-multi-key", TestCase, &fixture_knownhost_sssd_known_multi_key,
+              setup, test_echo_and_close, teardown);
+  g_test_add ("/ssh-bridge/knownhost-sssd-unknown", TestCase, &fixture_knownhost_sssd_unknown,
+              setup, test_problem, teardown);
+  g_test_add ("/ssh-bridge/knownhost-sssd-badkey", TestCase, &fixture_knownhost_sssd_badkey,
+              setup, test_problem, teardown);
+
   g_test_add ("/ssh-bridge/hostkey-unknown", TestCase, &fixture_prompt_host_key,
               setup, test_hostkey_unknown, teardown);
   g_test_add ("/ssh-bridge/hostkey-conversation", TestCase, &fixture_prompt_host_key,
diff --git a/test/verify/check-realms b/test/verify/check-realms
index 31bf6ab263c3..f17ae4b05d81 100755
--- a/test/verify/check-realms
+++ b/test/verify/check-realms
@@ -181,6 +181,7 @@ class TestRealms(MachineCase):
             b.wait_in_text('#service-unit', "dead")
             b.logout()
             b.password = orig_password
+            m.execute("chown -R admin /home/admin")
 
             self.allow_authorize_journal_messages()
 
@@ -191,6 +192,25 @@ class TestRealms(MachineCase):
                     ['curl', '-s', '--negotiate', '--delegation', 'always', '-u:', '-D-',
                      'http://x0.cockpit.lan:9090/cockpit/login'])
 
+        # check respecting FreeIPA's/sssd's ssh known host keys; this requires the new
+        # --privkey option of sss_ssh_knownhostproxy, thus only works on recent images
+        b.login_and_go("/dashboard")
+        b.wait_present('#dashboard-add')
+        b.click('#dashboard-add')
+        b.wait_popup('dashboard_setup_server_dialog')
+        b.set_val('#add-machine-address', 'x0.cockpit.lan')
+        b.wait_text('#dashboard_setup_server_dialog .btn-primary', "Add")
+        b.wait_present("#dashboard_setup_server_dialog .btn-primary:not([disabled])")
+        b.click('#dashboard_setup_server_dialog .btn-primary')
+
+        # with --pubkey support this should Just Work, otherwise confirm fingerprint
+        if '--pubkey' not in m.execute("sss_ssh_knownhostsproxy --help || true"):
+            b.wait_in_text('#dashboard_setup_server_dialog', "Fingerprint")
+            b.click('#dashboard_setup_server_dialog .btn-primary')
+        b.wait_popdown('dashboard_setup_server_dialog')
+        b.wait_present("#dashboard-hosts a[data-address='x0.cockpit.lan']")
+        b.logout()
+
         # Leave the domain
         b.login_and_go("/system")
         b.wait_present("#system-info-domain a")
@@ -479,8 +499,10 @@ class TestKerberos(MachineCase):
         b.wait_present("#troubleshoot-dialog .btn-primary:not([disabled])")
         b.wait_text('#troubleshoot-dialog .btn-primary', "Add")
         b.click('#troubleshoot-dialog .btn-primary')
-        b.wait_in_text('#troubleshoot-dialog', "Fingerprint")
-        b.click('#troubleshoot-dialog .btn-primary')
+        # with --pubkey support the fingerprint is already known, otherwise confirm fingerprint
+        if '--pubkey' not in m.execute("sss_ssh_knownhostsproxy --help || true"):
+            b.wait_in_text('#troubleshoot-dialog', "Fingerprint")
+            b.click('#troubleshoot-dialog .btn-primary')
         b.wait_in_text('#troubleshoot-dialog h4', "Log in to")
         b.wait_present("#troubleshoot-dialog .btn-primary:not([disabled])")
         b.wait_present("#login-type button")
